% camadacompet.m
% Treinamento n?o supervisionado de uma camada competitiva
%
% @AB LARA/UnB 15/4/2019

cla
clf
N=10;                % Numero vetores de treinamento  ...30
Nc=6;                % N?mero de classes (vetores de c?digo).

x=[rands(2,N) rand(2,2*N) -rand(2,2*N)]; % pdf
figure(1); clf
plot(x(1,:),x(2,:),'ko'), hold on

net = competlayer(Nc);    % Numero de classes (vetores de codigo)...6
net.trainParam.epochs=100;
net = train(net,x);
view(net)
y = net(x);
classes = vec2ind(y);

% for i=1:Nc
%     if classes(i)==1,plot(x(1,i),x(2,i),'bo');end
%     if classes(i)==2,plot(x(1,i),x(2,i),'ro');end
%     if classes(i)==3,plot(x(1,i),x(2,i),'ko');end
%     if classes(i)==4,plot(x(1,i),x(2,i),'go');end
%     if classes(i)==5,plot(x(1,i),x(2,i),'co');end
%     if classes(i)==6,plot(x(1,i),x(2,i),'mo');end
% end

plot(net.IW{:,1}(:,1),net.IW{:,1}(:,2),'ro','LineWidth',20)
grid
title('Camada Competitiva, pdf=[rands(2,N) rand(2,2*N) -rand(2,N)','FontSize',14)
legend({'Dados Trein.','Vetores de Codigo','Classe 1 bo','Classe 2 ro','Classe 3 ko',...
    'Classe 4 go','Classe 5 co','Classe 6 mo'},'FontSize',14);


% return
%keyboard
pause

x=rands(2,100*Nc);
y = net(x);
classes = vec2ind(y);

for i=1:100*Nc
    if classes(i)==1,plot(x(1,i),x(2,i),'bx');end
    if classes(i)==2,plot(x(1,i),x(2,i),'rx');end
    if classes(i)==3,plot(x(1,i),x(2,i),'kx');end
    if classes(i)==4,plot(x(1,i),x(2,i),'gx');end
    if classes(i)==5,plot(x(1,i),x(2,i),'cx');end
    if classes(i)==6,plot(x(1,i),x(2,i),'mx');end
end

net.b{:}
pause

%%
%
figure(3)
clf
plot(net.IW{:,1}(:,1),net.IW{:,1}(:,2),'ro','LineWidth',20)
hold on
grid
title('Camada Competitiva, pdf=[rands(2,N) rand(2,2*N) -rand(2,N)','FontSize',14)
legend({'Dados Trein.','Vetores de Codigo','Classe 1 bo','Classe 2 ro','Classe 3 ko',...
    'Classe 4 go','Classe 5 co','Classe 6 mo'},'FontSize',14);

net.b{1:1}=zeros(6,1);
x=rands(2,100*Nc);
y = net(x);
classes = vec2ind(y);

for i=1:100*Nc
    if classes(i)==1,plot(x(1,i),x(2,i),'bx');end
    if classes(i)==2,plot(x(1,i),x(2,i),'rx');end
    if classes(i)==3,plot(x(1,i),x(2,i),'kx');end
    if classes(i)==4,plot(x(1,i),x(2,i),'gx');end
    if classes(i)==5,plot(x(1,i),x(2,i),'cx');end
    if classes(i)==6,plot(x(1,i),x(2,i),'mx');end
end

